package Mooix::Error;
my $dying=0;
sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self  = {};
	$self->{object} = shift;
	$self->{message} = shift;
	bless ($self, $class);
	return $self;
}
sub get {
	my $this=shift;
	return $this->{message}."\ncallstack:\n";
	       join("\n\t", $this->{object}->calltrace)."\n";
}
use overload '""' => sub {
	my $this=shift;
	
	$SIG{__DIE__} = sub {
		my $error=shift;
		return if $error !~ /\ncallstack:\n/s;
		return if ! defined $^S || $^S;
		if (! $dying) {
			$dying=1;
			die $error."\t".join("\n\t", $this->{object}->calltrace)."\n"
		}
		else {
			die "error generating calltrace";
		}
			
	};
	$this->{message}."\ncallstack:\n";
};
1
