package Mooix::CallStack;
require XSLoader;
XSLoader::load('Mooix::CallStack');
use Mooix::Thing;
sub get {
	return load(file($<), 0);
}
sub calledby {
	my $callindex=shift()->index;
	my $callmeth=shift;
	my $caller_last=shift || 0;
	my $ret=0;
	my $stack=get();
	my $this=$stack->index;
	my $thismeth=$stack->basemethod;
	$stack=$stack->nextsegment;
	while ($stack) {
		if ($stack->index eq $callindex &&
		    (! length $callmeth || $stack->basemethod eq $callmeth)) {
			$ret=1;
			last unless $caller_last;
		}
		elsif (! $ret && $stack->index == $this &&
		       $stack->basemethod eq $thismeth) {
		}
		else {
			return 0;
		}
		$stack=$stack->nextsegment;
	}
	return $ret;
}
sub index {
	my $this=shift;
	return $this->dev.".".$this->inode;
}
sub basemethod {
	my $this=shift;
	my ($basemethod) = $this->method =~ m!(?:.*/)?(.*)!;
	return $basemethod;
}
sub nextsegment {
	my $stack=shift()->next;
	while ($stack) {
		return $stack if $stack->boundry;
		$stack=$stack->next;
	}
}
sub iterator {
	return Mooix::CallStack::Iter::start();
}
  
1
